/* Copyright 2011 Fredrik Wikstrom. All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions
** are met:
**
** 1. Redistributions of source code must retain the above copyright
**    notice, this list of conditions and the following disclaimer.
**
** 2. Redistributions in binary form must reproduce the above copyright
**    notice, this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS `AS IS'
** AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
** IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
** ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
** LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
*/

#include "vditool.h"

RAWFILE *open_raw (CONST_STRPTR filename, int32 mode) {
	RAWFILE *raw;
	raw = IExec->AllocVecTags(sizeof(RAWFILE),
		AVT_ClearWithValue, 0,
		TAG_END);
	if (raw) {
		raw->filename = filename;
		raw->file = IDOS->Open(filename, mode);
		if (raw->file) {
			return raw;
		} else {
			IDOS->PrintFault(IDOS->IoErr(), filename);
		}
		close_raw(raw);
	} else {
		IDOS->PrintFault(ERROR_NO_FREE_STORE, PROGNAME);
	}
	return NULL;
}

void close_raw (RAWFILE *raw) {
	if (raw) {
		IDOS->Close(raw->file);
		IExec->FreeVec(raw);
	}
}
